library Core;

{ Important note about DLL memory management: ShareMem must be the
  first unit in your library's USES clause AND your project's (select
  Project-View Source) USES clause if your DLL exports any procedures or
  functions that pass strings as parameters or function results. This
  applies to all strings passed to and from your DLL--even those that
  are nested in records and classes. ShareMem is the interface unit to
  the BORLNDMM.DLL shared memory manager, which must be deployed along
  with your DLL. To avoid using BORLNDMM.DLL, pass string information
  using PChar or ShortString parameters. }

uses
  Windows,
  SysUtils,
  Classes,
  Unit1 in 'Unit1.pas' {Form1},
  Hook in 'Hook.pas';

{$R *.res}

type
  TFormThread = class(TThread)
  protected
    procedure Execute; override;
  end;

var
  hinst: DWORD;

procedure MainDll(Reason: DWORD);
begin
  if Reason = DLL_PROCESS_ATTACH then begin
    hinst := HInstance;
    TFormThread.Create(False);
  end;
end;

{ TFormThread }

procedure TFormThread.Execute;
begin
  Form1 := TForm1.Create(nil);
  Form1.ShowModal;
  FreeLibraryAndExitThread(hinst, 0);
end;

begin
  DllProc := @MainDll;
  DllProc(DLL_PROCESS_ATTACH);
end.

